locals {
  default_tags = {
    ManagedBy   = "Terraform"
    Application = var.application
    Environment = var.environment
    Region      = var.region
  }

  current_account_id = data.aws_caller_identity.current.account_id
  resource_prefix    = "${var.application}-${var.environment}-${var.region}"
}